//////////////
// Textures //
//////////////
#declare Blue_Diamond_Texture =
texture {
  tiles {
    texture {
      pigment {
        color red 0.80 green 0.90 blue 1.00 filter 0.99
      }
      finish {
        specular 1
        roughness 0.001
        diffuse 0
        reflection 0.99
        refraction 1
        ior 2.417
        ambient 0.5
      }
    }
  tile2
    texture {
      tiles {
        texture {
          pigment {
            color red 0.80 green 0.90 blue 1.00 filter 0.99
          }
          finish {
            specular 1
            roughness 0.001
            diffuse 0
            reflection 0.99
            refraction 1
            ior 2.417
            ambient 0.5
          }
        }
      tile2
        texture {
          pigment {
            gradient x
            turbulence 1
            omega 0.8
            color_map {
              [0.00 color red 0.80 green 0.90 blue 1.00 filter 0.99]
              [0.60 color red 0.80 green 0.90 blue 1.00 filter 0.99]
              [0.60 color red 1.00 green 0.80 blue 0.80 filter 0.99]
              [0.70 color red 1.00 green 1.00 blue 0.80 filter 0.99]
              [0.80 color red 0.80 green 1.00 blue 0.80 filter 0.99]
              [0.90 color red 0.80 green 0.80 blue 1.00 filter 0.99]
              [1.00 color red 1.00 green 0.80 blue 1.00 filter 0.99]
            }
          }
          finish {
            specular 1
            roughness 0.001
            diffuse 0
            reflection 0.99
            refraction 1
            ior 2.417
            ambient 0.5
          }
          scale <30, 30, 30>
        }
      }
      scale <0.2, 0.2, 0.2>
    }
  }
  translate <-0.5, 0, 0.5>
  scale <1.2, 5, 1.2>
}

#declare Chrysopras_Texture =
texture {
  pigment {
    bozo
    color_map {
      [0 1 color red 0.00 green 0.50 blue 0.20 filter 0.47 color red 0.00 green 0.55 blue 0.45 filter 0.47]
    }
  }
  finish {
    specular 1
    roughness 0.0007
    brilliance 0.1
    diffuse 0.7
    reflection 0.1
  }
}

#declare Diamond_Texture =
texture {
  tiles {
    texture {
      pigment {
        color red 1.00 green 1.00 blue 1.00 filter 0.99
      }
      finish {
        specular 1
        roughness 0.001
        diffuse 0
        reflection 0.99
        refraction 1
        ior 2.417
        ambient 0.5
      }
    }
  tile2
    texture {
      tiles {
        texture {
          pigment {
            color red 1.00 green 1.00 blue 1.00 filter 0.99
          }
            finish {
            specular 1
            roughness 0.001
            diffuse 0
            reflection 0.99
            refraction 1
            ior 2.417
            ambient 0.5
          }
        }
      tile2
        texture {
          pigment {
            gradient x
            turbulence 1
            omega 0.8
            color_map {
              [0.00 color red 1.00 green 1.00 blue 1.00 filter 0.99]
              [0.60 color red 1.00 green 1.00 blue 1.00 filter 0.99]
              [0.60 color red 1.00 green 0.80 blue 0.80 filter 0.99]
              [0.70 color red 1.00 green 1.00 blue 0.80 filter 0.99]
              [0.80 color red 0.80 green 1.00 blue 0.80 filter 0.99]
              [0.90 color red 0.80 green 0.80 blue 1.00 filter 0.99]
              [1.00 color red 1.00 green 0.80 blue 1.00 filter 0.99]
            }
          }
          finish {
            specular 1
            roughness 0.001
            diffuse 0
            reflection 0.99
            refraction 1
            ior 2.417
            ambient 0.5
          }
          scale <30, 30, 30>
        }
      }
      scale <0.2, 0.2, 0.2>
    }
  }
  translate <-0.5, 0, 0.5>
  scale <1.2, 5, 1.2>
}

#declare Emerald_Texture =
texture {
  pigment {
    color red 0.35 green 0.95 blue 0.70 filter 0.90
  }
  finish {
    specular 1
    roughness 0.001
    diffuse 0
    reflection 0.99
    refraction 1
    ior 1.58
    ambient 0.3
  }
}

#declare Opal_Texture =
texture {
  pigment {
    granite
    color_map {
      [0.00 color red 0.00 green 0.50 blue 0.40 filter 0.30]
      [0.20 color red 0.10 green 0.45 blue 0.60 filter 0.30]
      [0.50 color red 0.10 green 0.30 blue 0.60 filter 0.30]
      [1.00 color red 1.00 green 0.45 blue 0.45 filter 0.30]
    }
  }
  finish {
    specular 1
    roughness 0.0007
    brilliance 0.1
    diffuse 0.7
    reflection 0.1
  }
  scale <0.5, 0.5, 0.5>
}

#declare Pink_Diamond_Texture =
texture {
  tiles {
    texture {
      pigment {
        color red 1.00 green 0.90 blue 0.95 filter 0.99
      }
      finish {
        specular 1
        roughness 0.001
        diffuse 0
        reflection 0.99
        refraction 1
        ior 2.417
        ambient 0.5
      }
    }
  tile2
    texture {
      tiles {
        texture {
          pigment {
            color red 1.00 green 0.90 blue 0.95 filter 0.99
          }
          finish {
            specular 1
            roughness 0.001
            diffuse 0
            reflection 0.99
            refraction 1
            ior 2.417
            ambient 0.5
          }
        }
      tile2
        texture {
          pigment {
            gradient x
            turbulence 1
            omega 0.8
            color_map {
              [0.00 color red 1.00 green 0.90 blue 0.95 filter 0.99]
              [0.60 color red 1.00 green 0.90 blue 0.95 filter 0.99]
              [0.60 color red 1.00 green 0.80 blue 0.80 filter 0.99]
              [0.70 color red 1.00 green 1.00 blue 0.80 filter 0.99]
              [0.80 color red 0.80 green 1.00 blue 0.80 filter 0.99]
              [0.90 color red 0.80 green 0.80 blue 1.00 filter 0.99]
              [1.00 color red 1.00 green 0.80 blue 1.00 filter 0.99]
            }
          }
          finish {
            specular 1
            roughness 0.001
            diffuse 0
            reflection 0.99
            refraction 1
            ior 2.417
            ambient 0.5
          }
          scale <30, 30, 30>
        }
      }
      scale <0.2, 0.2, 0.2>
    }
  }
  translate <-0.5, 0, 0.5>
  scale <1.2, 5, 1.2>
}

#declare Ruby_Texture =
texture {
  pigment {
    color red 1.00 green 0.50 blue 0.55 filter 0.95
  }
  finish {
    specular 1
    roughness 0.001
    diffuse 0
    reflection 0.99
    refraction 1
    ior 1.77
    ambient 0.4
  }
}

#declare Saphire_Texture =
texture {
  pigment {
    color red 0.60 green 0.85 blue 1.00 filter 0.95
  }
  finish {
    specular 1
    roughness 0.001
    diffuse 0
    reflection 0.99
    refraction 1
    ior 1.77
    ambient 0.4
  }
}

// Layer one of star ruby. Make the star by three layers of this turned 0 30 and 60 degrees.
#declare StarRuby_Texture_1 =
texture {
  pigment {
    marble
    color_map {
      [0.00 color red 1.00 green 0.90 blue 0.96 filter 0.45]
      [0.01 color red 1.00 green 0.90 blue 0.96 filter 1.00]
      [1.00 color red 1.00 green 0.90 blue 0.96 filter 1.00]
    }
  }
  finish {
    specular 1
    roughness 0.001
    brilliance 1.8
    diffuse 0.7
  }
  scale <10, 10, 10>
  rotate <0, 0, 0>
}

// Layer two of star ruby.
#declare StarRuby_Texture_2 =
texture {
  pigment {
    granite
    turbulence 0.7
    color_map {
      [0.00 color red 1.00 green 0.23 blue 0.55 filter 0.30]
      [0.20 color red 0.93 green 0.23 blue 0.35 filter 0.35]
      [1.00 color red 0.93 green 0.23 blue 0.35 filter 0.55]
    }
  }
  finish {
    specular 1
    roughness 0.001
    diffuse 0.3
    refraction 1
    ior 1.77
    ambient 0.4
  }
}

// Layer one of star saphire. Make the star by three layers of this turned 0 30 and 60 degrees.
#declare StarSaphire_Texture_1 =
texture {
  pigment {
    marble
    color_map {
      [0.00 color red 0.85 green 0.95 blue 1.00 filter 0.45]
      [0.01 color red 0.85 green 0.95 blue 1.00 filter 1.00]
      [1.00 color red 0.85 green 0.95 blue 1.00 filter 1.00]
    }
  }
  finish {
    specular 1
    roughness 0.001
    brilliance 1.8
    diffuse 0.7
  }
  scale <10, 10, 10>
  rotate <0, 0, 0>
}

// Layer two of star saphire.
#declare StarSaphire_Texture_2 =
texture {
  pigment {
    granite
    turbulence 0.7
    color_map {
      [0.00 color red 0.10 green 0.60 blue 0.75 filter 0.35]
      [0.20 color red 0.10 green 0.55 blue 0.75 filter 0.40]
      [1.00 color red 0.10 green 0.55 blue 0.75 filter 0.50]
    }
  }
  finish {
    specular 1
    roughness 0.001
    diffuse 0.3
    refraction 1
    ior 1.77
    ambient 0.4
  }
}


/////////////
// Objects //
/////////////
#declare Brillant57 =
difference {
  intersection {
    union {
      cone { <0, -2, 0> 0 <0, 0, 0> 1 }
      cone { <0, 2, 0> 0 <0, 0, 0> 1 }
    }
  cylinder { <0, -4, 0> <0, 4, 0> 0.97 }
  }
  union {
    box { <-4, 0.324, -4> <4, 4, 4> }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -34.50>
        translate <1, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 34.50>
        translate <-1, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-34.50, 0, 0>
        translate <0, 0, -1>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <34.50, 0, 0>
        translate <0, 0, 1>
      }
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -34.50>
        translate <1, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 34.50>
        translate <-1, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-34.50, 0, 0>
        translate <0, 0, -1>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <34.50, 0, 0>
        translate <0, 0, 1>
      }
      rotate <0, 45, 0>
    }
    union {
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, -40.75>
        translate <-1, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, 40.75>
        translate <1, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <-40.75, 0, 0>
        translate <0, 0, 1>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <40.75, 0, 0>
        translate <0, 0, -1>
      }
    }
    union {
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, -40.75>
        translate <-1, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, 40.75>
        translate <1, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <-40.75, 0, 0>
        translate <0, 0, 1>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <40.75, 0, 0>
        translate <0, 0, -1>
      }
      rotate <0, 45, 0>
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -22>
        translate <1.285, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 22>
        translate <-1.285, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-22, 0, 0>
        translate <0, 0, -1.285>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <22, 0, 0>
        translate <0, 0, 1.285>
      }
      rotate <0, -22.5, 0>
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -22>
        translate <1.285, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 22>
        translate <-1.285, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-22, 0, 0>
        translate <0, 0, -1.285>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <22, 0, 0>
        translate <0, 0, 1.285>
      }
      rotate <0, 22.5, 0>
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -40>
        translate <0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 40>
        translate <-0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-40, 0, 0>
        translate <0, 0, -0.98>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <40, 0, 0>
        translate <0, 0, 0.98>
      }
      rotate <0, -11.25, 0>
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -40>
        translate <0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 40>
        translate <-0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-40, 0, 0>
        translate <0, 0, -0.98>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <40, 0, 0>
        translate <0, 0, 0.98>
      }
      rotate <0, -33.75, 0>
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -40>
        translate <0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 40>
        translate <-0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-40, 0, 0>
        translate <0, 0, -0.98>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <40, 0, 0>
        translate <0, 0, 0.98>
      }
      rotate <0, 11.25, 0>
    }
    union {
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, -40>
        translate <0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <0, 0, 40>
        translate <-0.98, 0, 0>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <-40, 0, 0>
        translate <0, 0, -0.98>
      }
      box { <-4, 0, -4> <4, 4, 4>
        rotate <40, 0, 0>
        translate <0, 0, 0.98>
      }
      rotate <0, 33.75, 0>
    }
    union {
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, -42.5>
        translate <-0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, 42.5>
        translate <0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <-42.5, 0, 0>
        translate <0, 0, 0.982>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <42.5, 0, 0>
        translate <0, 0, -0.982>
      }
      rotate <0, -11.25, 0>
    }
    union {
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, -42.5>
        translate <-0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, 42.5>
        translate <0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <-42.5, 0, 0>
        translate <0, 0, 0.982>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <42.5, 0, 0>
        translate <0, 0, -0.982>
      }
      rotate <0, -33.75, 0>
    }
    union {
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, -42.5>
        translate <-0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, 42.5>
        translate <0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <-42.5, 0, 0>
        translate <0, 0, 0.982>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <42.5, 0, 0>
        translate <0, 0, -0.982>
      }
      rotate <0, 11.25, 0>
    }
    union {
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, -42.5>
        translate <-0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <0, 0, 42.5>
        translate <0.982, 0, 0>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <-42.5, 0, 0>
        translate <0, 0, 0.982>
      }
      box { <-4, -4, -4> <4, 0, 4>
        rotate <42.5, 0, 0>
        translate <0, 0, -0.982>
      }
      rotate <0, 33.75, 0>
    }
  }
  bounded_by {
    sphere { <0, 0, 0> 1 }
  }
}

#declare Brillant58 =
difference {
  object { Brillant57 }
  box { <-4, -4, -4> <4, -0.82, 4> }
  bounded_by {
    sphere { <0, 0, 0> 1 }
  }
}

#declare Stairs =
difference {
  box { <-1.8, -1.0, -1.3> <1.8, 1.0, 1.3> }
  union {
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 0>
      translate <0, 0.4, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.8, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -40>
      translate <1.8, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.9, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -30>
      translate <1.9, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-2.4, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -17>
      translate <2.4, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <40, 0, 0>
      translate <0, 0, 1.3>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-40, 0, 0>
      translate <0, 0, -1.3>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <30, 0, 0>
      translate <0, 0, 1.4>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-30, 0, 0>
      translate <0, 0, -1.4>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <17, 0, 0>
      translate <0, 0, 1.9>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-17, 0, 0>
      translate <0, 0, -1.9>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 50>
      translate <1.8, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.8, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 40>
      translate <1.9, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.9, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 27>
      translate <2.4, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-2.4, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <50, 0, 0>
      translate <0, 0, -1.3>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-50, 0, 0>
      translate <0, 0, 1.3>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <40, 0, 0>
      translate <0, 0, -1.4>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-40, 0, 0>
      translate <0, 0, 1.4>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <27, 0, 0>
      translate <0, 0, -1.9>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-27, 0, 0>
      translate <0, 0, 1.9>
    }
  }
  bounded_by {
    box { <-1.9, -1.0, -1.4> <1.9, 1.0, 1.4> }
  }
}


#declare Square_Stairs =
difference {
  box { <-1.3, -1.0, -1.3> <1.3, 1.0, 1.3> }
  union {
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 0>
      translate <0, 0.4, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.3, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -40>
      translate <1.3, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.4, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -30>
      translate <1.4, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-1.9, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -17>
      translate <1.9, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <40, 0, 0>
      translate <0, 0, 1.3>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-40, 0, 0>
      translate <0, 0, -1.3>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <30, 0, 0>
      translate <0, 0, 1.4>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-30, 0, 0>
      translate <0, 0, -1.4>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <17, 0, 0>
      translate <0, 0, 1.9>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-17, 0, 0>
      translate <0, 0, -1.9>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 50>
      translate <1.3, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.3, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 40>
      translate <1.4, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.4, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 27>
      translate <1.9, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-1.9, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <50, 0, 0>
      translate <0, 0, -1.3>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-50, 0, 0>
      translate <0, 0, 1.3>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <40, 0, 0>
      translate <0, 0, -1.4>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-40, 0, 0>
      translate <0, 0, 1.4>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <27, 0, 0>
      translate <0, 0, -1.9>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-27, 0, 0>
      translate <0, 0, 1.9>
    }
  }
  bounded_by {
    box { <-1.4, -1.0, -1.4> <1.4, 1.0, 1.4> }
  }
}

#declare Emerald_Stairs =
difference {
  box { <-1.8, -1.0, -1.3> <1.8, 1.0, 1.3> }
  union {
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 0>
      translate <0, 0.4, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.8, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -40>
      translate <1.8, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.9, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -30>
      translate <1.9, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-2.4, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, -17>
      translate <2.4, 0, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <40, 0, 0>
      translate <0, 0, 1.3>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-40, 0, 0>
      translate <0, 0, -1.3>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <30, 0, 0>
      translate <0, 0, 1.4>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-30, 0, 0>
      translate <0, 0, -1.4>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <17, 0, 0>
      translate <0, 0, 1.9>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <-17, 0, 0>
      translate <0, 0, -1.9>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 50>
      translate <1.8, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.8, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 40>
      translate <1.9, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.9, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, 27>
      translate <2.4, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-2.4, 0, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <50, 0, 0>
      translate <0, 0, -1.3>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-50, 0, 0>
      translate <0, 0, 1.3>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <40, 0, 0>
      translate <0, 0, -1.4>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-40, 0, 0>
      translate <0, 0, 1.4>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <27, 0, 0>
      translate <0, 0, -1.9>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <-27, 0, 0>
      translate <0, 0, 1.9>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.65, 0, 0>
      rotate <0, 45, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.65, 0, 0>
      rotate <0, -45, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.65, 0, 0>
      rotate <0, 135, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 40>
      translate <-1.65, 0, 0>
      rotate <0, -135, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.75, 0, 0>
      rotate <0, 45, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.75, 0, 0>
      rotate <0, -45, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.75, 0, 0>
      rotate <0, 135, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 30>
      translate <-1.75, 0, 0>
      rotate <0, -135, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-2.25, 0, 0>
      rotate <0, 45, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-2.25, 0, 0>
      rotate <0, -45, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-2.25, 0, 0>
      rotate <0, 135, 0>
    }
    box { <-3, 0, -3> <3, 3, 3>
      rotate <0, 0, 17>
      translate <-2.25, 0, 0>
      rotate <0, -135, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.65, 0, 0>
      rotate <0, 45, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.65, 0, 0>
      rotate <0, -45, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.65, 0, 0>
      rotate <0, 135, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -50>
      translate <-1.65, 0, 0>
      rotate <0, -135, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.75, 0, 0>
      rotate <0, 45, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.75, 0, 0>
      rotate <0, -45, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.75, 0, 0>
      rotate <0, 135, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -40>
      translate <-1.75, 0, 0>
      rotate <0, -135, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-2.25, 0, 0>
      rotate <0, 45, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-2.25, 0, 0>
      rotate <0, -45, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-2.25, 0, 0>
      rotate <0, 135, 0>
    }
    box { <-3, -3, -3> <3, 0, 3>
      rotate <0, 0, -27>
      translate <-2.25, 0, 0>
      rotate <0, -135, 0>
    }
  }
  bounded_by {
    box { <-1.9, -1.0, -1.4> <1.9, 1.0, 1.4> }
  }
}

#declare Cabochon =
intersection {
  sphere { <0, 0, 0> 1 }
  box { <-1.1, 0, -1.1> <1.1, 1.1, 1.1> }
  scale <1, 0.5, 1>
}
